<script>
  import { _ } from "svelte-i18n";
  import { clickOutside } from "../base/outsideclick";
  import { focusTrap } from "svelte-focus-trap";
  import { RunnerCardService } from "@odit/lfk-client-js";
  import Toastify from "toastify-js";
  export let bulk_modal_open;
  export let current_cards;
  function focus(el) {
    el.focus();
  }
  $: card_count = 0;
  $: is_card_count_valid = card_count > 0;
  $: processed_last_submit = true;
  $: createbtnenabled = is_card_count_valid;
  (() => {
    document.onkeydown = (e) => {
      e = e || window.event;
      if (e.key === "Escape") {
        bulk_modal_open = false;
      }
      if (e.keyCode === 13) {
        if (createbtnenabled === true) {
          createbtnenabled = false;
          submit_with_print();
        }
      }
    };
  })();
  function submit_without_print() {
    if (processed_last_submit === true) {
      processed_last_submit = false;
      const toast = Toastify({
        text: $_("creating-blanco-cards"),
        duration: -1,
      }).showToast();
      RunnerCardService.runnerCardControllerPostBlancoBulk(card_count, false)
        .then((result) => {
          bulk_modal_open = false;
          //
          Toastify({
            text: $_("created-blanco-cards"),
            duration: 500,
            backgroundColor: "linear-gradient(to right, #00b09b, #96c93d)",
          }).showToast();
        })
        .catch((err) => {
          //
        })
        .finally(() => {
          processed_last_submit = true;
          //
          toast.hideToast();
        });
    }
  }

  function submit_with_print() {
    if (processed_last_submit === true) {
      processed_last_submit = false;
      const toast = Toastify({
        text: $_("creating-blanco-cards"),
        duration: -1,
      }).showToast();
      RunnerCardService.runnerCardControllerPostBlancoBulk(card_count, true)
        .then((result) => {
          bulk_modal_open = false;
          //
          Toastify({
            text: $_("created-blanco-cards"),
            duration: 500,
            backgroundColor: "linear-gradient(to right, #00b09b, #96c93d)",
          }).showToast();
          current_cards = current_cards.concat(result);
          const toast = Toastify({
            text: $_("generating-pdf"),
            duration: -1,
          }).showToast();
          fetch(
            `${config.baseurl_documentserver}/cards?&download=true&key=${config.documentserver_key}`,
            {
              method: "POST",
              headers: {
                "Content-Type": "application/json",
              },
              body: JSON.stringify(result),
            }
          )
            .then((response) => {
              if (response.status != "200") {
                toast.hideToast();
                Toastify({
                  text: $_("pdf-generation-failed"),
                  duration: 3500,
                  backgroundColor:
                    "linear-gradient(90deg, hsla(281, 37%, 45%, 1) 0%, hsla(1, 62%, 48%, 1) 100%)",
                }).showToast();
              } else {
                return response.blob();
              }
            })
            .then((blob) => {
              const url = window.URL.createObjectURL(blob);
              let a = document.createElement("a");
              a.href = url;
              a.download = "Bulkcards.pdf";
              document.body.appendChild(a);
              a.click();
              a.remove();
              toast.hideToast();
              Toastify({
                text: $_("pdf-successfully-generated"),
                duration: 3500,
                backgroundColor: "linear-gradient(to right, #00b09b, #96c93d)",
              }).showToast();
            })
            .catch((err) => {
              console.error(err);
            });
        })
        .catch((err) => {
          //
        })
        .finally(() => {
          processed_last_submit = true;
          //
          toast.hideToast();
        });
    }
  }
</script>

{#if bulk_modal_open}
  <div
    class="fixed z-10 inset-0 overflow-y-auto"
    use:focusTrap
    use:clickOutside
    on:click_outside={() => {
      bulk_modal_open = false;
    }}>
    <div
      class="flex items-end justify-center min-h-screen pt-4 px-4 pb-20 text-center sm:block sm:p-0">
      <div class="fixed inset-0 transition-opacity" aria-hidden="true">
        <div
          class="absolute inset-0 bg-gray-500 opacity-75"
          data-id="modal_backdrop" />
      </div>
      <span
        class="hidden sm:inline-block sm:align-middle sm:h-screen"
        aria-hidden="true">&#8203;</span>
      <div
        class="inline-block align-bottom bg-white rounded-lg text-left shadow-xl transform transition-all sm:my-8 sm:align-middle sm:max-w-2xl sm:w-full"
        role="dialog"
        aria-modal="true"
        aria-labelledby="modal-headline">
        <div class="bg-white px-4 pt-5 pb-4 sm:p-6 sm:pb-4">
          <div class="sm:flex sm:items-start">
            <div
              class="mx-auto flex-shrink-0 flex items-center justify-center h-12 w- rounded-full bg-blue-100 sm:mx-0 sm:h-10 sm:w-10">
              <svg
                class="h-6 w-6 text-blue-600"
                fill="currentColor"
                xmlns="http://www.w3.org/2000/svg"
                viewBox="0 0 24 24"
                width="24"
                height="24"><path fill="none" d="M0 0h24v24H0z" />
                <path
                  fill="currentColor"
                  d="M22 10v10a1 1 0 01-1 1H3a1 1 0 01-1-1V10h20zm0-2H2V4a1 1 0 011-1h18a1 1 0 011 1v4zm-7 8v2h4v-2h-4z" /></svg>
            </div>
            <div class="mt-3 text-center sm:mt-0 sm:ml-4 sm:text-left">
              <h3 class="text-lg leading-6 font-medium text-gray-900">
                {$_('create-bulk-blanco-cards')}
              </h3>
              <div class="mt-2 mb-6">
                <p class="text-sm text-gray-500">
                  {$_('just-enter-how-many-you-want-and-the-system-will-create-them')}
                </p>
              </div>
              <div class="grid grid-cols-6 gap-6">
                <div class="col-span-6">
                  <label
                    for="amount"
                    class="block text-sm font-medium text-gray-700">{$_('amount')}</label>
                  <div class="mt-1 flex rounded-md shadow-sm">
                    <input
                      autocomplete="off"
                      class:border-red-500={!is_card_count_valid}
                      class:focus:border-red-500={!is_card_count_valid}
                      class:focus:ring-red-500={!is_card_count_valid}
                      bind:value={card_count}
                      type="number"
                      step="1"
                      name="amount"
                      class="focus:ring-indigo-500 focus:border-indigo-500 flex-1 block w-full rounded-none rounded-l-md sm:text-sm border-gray-300 border bg-gray-50 text-gray-500 p-2"
                      placeholder="400" />
                    <span
                      class="inline-flex items-center px-3 rounded-r-md border border-gray-300 bg-gray-50 text-gray-500 text-sm">{$_('cards')}</span>
                  </div>
                  {#if !is_card_count_valid}
                    <span
                      class="flex items-center font-medium tracking-wide text-red-500 text-xs mt-1 ml-1">
                      {$_('you-must-create-at-least-one-card-or-cancel')}
                    </span>
                  {/if}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="bg-gray-50 px-4 py-3 sm:px-6 sm:flex sm:flex-row-reverse">
          <button
            disabled={!createbtnenabled}
            class:opacity-50={!createbtnenabled}
            on:click={submit_with_print}
            type="button"
            class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-blue-600 text-base font-medium text-white hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500 sm:ml-3 sm:w-auto sm:text-sm">
            {$_('create-and-generate-pdf')}
          </button>
          <button
            disabled={!createbtnenabled}
            class:opacity-50={!createbtnenabled}
            on:click={submit_without_print}
            type="button"
            class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-gray-400 text-base font-medium text-white hover:bg-gray-500 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500 sm:ml-3 sm:w-auto sm:text-sm">
            {$_('create-without-pdf')}
          </button>
          <button
            on:click={() => {
              bulk_modal_open = false;
            }}
            type="button"
            class="mr-auto mt-3 w-full inline-flex justify-center rounded-md border border-gray-300 shadow-sm px-4 py-2 bg-white text-base font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:mt-0 sm:ml-3 sm:w-auto sm:text-sm">
            {$_('cancel')}
          </button>
        </div>
      </div>
    </div>
  </div>
{/if}
